#! /bin/tcsh -f
#
#	use tracer to re-index a unit cell
#
#
#

set SG = "$1"
set CELL = "$2 $3 $4 $5 $6 $7"
set SG2 = "$8"

if("$SG2" == "") set SG2 = "$SG"

    set latt  = `echo $SG | awk '{print $1}'`
    set centering = `echo $SG | awk '/^[ABCIF]/{c=substr($1,1,1);print c"CENTERED"}'`
    set sys   = `awk -v SG=$SG '$4==SG{print $6}' ${CLIBD}/symop.lib`

    set latt2  = `echo $SG2 | awk '{print $1}'`
    set sys2   = `awk -v SG=$SG2 '$4==SG{print $6}' ${CLIBD}/symop.lib`
    if("$sys2" == "TRIGONAL") set sys2 = "HEXAGONAL"
    if("$SG2" == "P1") set CHOOSE_RC

    set test = `echo $latt $CELL | awk '{print ( /^[RH]/ && $5+0==90 && $6+0==90 && $7+0==120 )}'`
    if(0) then
	# get the rhombohedral cell - what you would get in indexing -
	set Hcell = ( $CELL )
 	echo "$Hcell" |\
	awk '{aH=$1;cH=$3;aR=sqrt(3*aH*aH+cH*cH)/3;\
	      sina2=3/2/sqrt(3+(cH/aH)^2);\
	      cosa2=sqrt(1-sina2^2);\
	      alphaR=atan2(sina2,cosa2)*2;\
	      alphaR=alphaR*90/atan2(1,0);\
	   print aR,aR,aR,alphaR,alphaR,alphaR}' |\
	cat >! Rcell.txt
	set CELL = `cat Rcell.txt`
	set reindex = "reindex hkl 2h/3+k/3+l/3,-h/3+k/3+l/3,-h/3-2k/3+l/3"
    endif
    set tCELL = ( $CELL )
    echo "$sys -> $sys2"

    set broken = 1
    set precision = 6
    set del = 1.0
    set tracer_sys = ""
    set last_tracer_sys = ""
    while ( $broken || ( "$tracer_sys" != "$sys2" ) )
	set del = `echo $del | awk '{print $1+0.5}'`
	( sleep 2 ; killall tracer & ) >& /dev/null
        tracer << EOF >! tracer.log
$centering
CELL $tCELL
DEL $del
REDUCE
EOF
        set broken = `grep Lattice tracer.log | wc -l | awk '{print ( $1 < 2 )}'`
	if( $broken ) then
	    echo "precision = $precision"
	    set tCELL = `echo $CELL | awk -v precision=$precision 'BEGIN{srand();s=10^precision} {printf "%.12f %.12f %.12f %.12f %.12f %.12f", $1+rand()/s,$2+rand()/s,$3+rand()/s,$4+rand()/s,$5+rand()/s,$6+rand()/s}'`
	    echo "trying new cell: $tCELL"
	    set precision = `echo $precision | awk '{print $1*0.9}'`
	endif
	set last_tracer_sys = "$tracer_sys"
	set tracer_sys = `awk '/Lattice Param/{print $7}' tracer.log | tail -1`
	if($?CHOOSE_RC) set tracer_sys = TRICLINIC
	if("$tracer_sys" != "$last_tracer_sys") then
	    echo "$sys -> $tracer_sys"
	endif
    end
    echo "del = $del"

    cat tracer.log |\
    awk '/Lattice [pP]arameters/{p=1}\
         p==1{print}\
         /Natural trigonometric/{p=0}\
    ' |\
    awk '/Lattice/{split($0,w,"--");type=w[2];no=$5}\
	no=="--"{no="(1)"}\
         /^ A /{A=$3;alpha=$6}\
         /^ B /{B=$3;beta=$6}\
         /^ C /{C=$3;gamma=$6}\
       /Natural trigonometric/{print A,B,C,alpha,beta,gamma,"\t",no,type}' |\
    tee cells.txt 

    cat tracer.log |\
    awk '$1=="CELL" && $4=="CELL" && $6=="CELL" && $9=="CELL" || \
         $1~/^CELL\(/ && $3~/^CELL\(/ && $4~/^CELL\(/ && $6~/^CELL\(/{\
	cell1=substr($1,5);cell2=substr($3,5)\
	if(NF==10){cell1=$2;cell2=$5}\
        getline;\
	while(NF==0) getline;\
	op1=op2=op3=""\
	if($1+0==1){op1=op1"+h";$1=""};\
	if($2+0==1){op1=op1"+k";$2=""};\
	if($3+0==1){op1=op1"+l";$3=""};\
	if($1+0==-1){op1=op1"-h";$1=""};\
	if($2+0==-1){op1=op1"-k";$2=""};\
	if($3+0==-1){op1=op1"-l";$3=""};\
	if($1+0!=0)op1=op1"+h/"1/$1;\
	if($2+0!=0)op1=op1"+k/"1/$2;\
	if($3+0!=0)op1=op1"+l/"1/$3;\
	getline;\
	if($1+0==1){op2=op2"+h";$1=""};\
	if($2+0==1){op2=op2"+k";$2=""};\
	if($3+0==1){op2=op2"+l";$3=""};\
	if($1+0==-1){op2=op2"-h";$1=""};\
	if($2+0==-1){op2=op2"-k";$2=""};\
	if($3+0==-1){op2=op2"-l";$3=""};\
	if($1+0!=0)op2=op2"+h/"1/$1;\
	if($2+0!=0)op2=op2"+k/"1/$2;\
	if($3+0!=0)op2=op2"+l/"1/$3;\
	getline;\
	if($1+0==1){op3=op3"+h";$1=""};\
	if($2+0==1){op3=op3"+k";$2=""};\
	if($3+0==1){op3=op3"+l";$3=""};\
	if($1+0==-1){op3=op3"-h";$1=""};\
	if($2+0==-1){op3=op3"-k";$2=""};\
	if($3+0==-1){op3=op3"-l";$3=""};\
	if($1+0!=0)op3=op3"+h/"1/$1;\
	if($2+0!=0)op3=op3"+k/"1/$2;\
	if($3+0!=0)op3=op3"+l/"1/$3;\
    print "# cell",cell1,"->",cell2\
    print "reindex hkl",op1","op2","op3}' 


    cat tracer.log |\
    awk '$1=="CELL" && $4=="CELL" && $6=="CELL" && $9=="CELL" || \
         $1~/^CELL\(/ && $3~/^CELL\(/ && $4~/^CELL\(/ && $6~/^CELL\(/{\
	cell1=substr($1,5);cell2=substr($3,5)\
	if(NF==10){cell1=$2;cell2=$5}\
        getline;\
	while(NF==0) getline;\
	op1=op2=op3=""\
	if($4+0==1){op1=op1"+h";$4=""};\
	if($5+0==1){op1=op1"+k";$5=""};\
	if($6+0==1){op1=op1"+l";$6=""};\
	if($4+0==-1){op1=op1"-h";$4=""};\
	if($5+0==-1){op1=op1"-k";$5=""};\
	if($6+0==-1){op1=op1"-l";$6=""};\
	if($4+0!=0)op1=op1"+h/"1/$4;\
	if($5+0!=0)op1=op1"+k/"1/$5;\
	if($6+0!=0)op1=op1"+l/"1/$6;\
	getline;\
	if($4+0==1){op2=op2"+h";$4=""};\
	if($5+0==1){op2=op2"+k";$5=""};\
	if($6+0==1){op2=op2"+l";$6=""};\
	if($4+0==-1){op2=op2"-h";$4=""};\
	if($5+0==-1){op2=op2"-k";$5=""};\
	if($6+0==-1){op2=op2"-l";$6=""};\
	if($4+0!=0)op2=op2"+h/"1/$4;\
	if($5+0!=0)op2=op2"+k/"1/$5;\
	if($6+0!=0)op2=op2"+l/"1/$6;\
	getline;\
	if($4+0==1){op3=op3"+h";$4=""};\
	if($5+0==1){op3=op3"+k";$5=""};\
	if($6+0==1){op3=op3"+l";$6=""};\
	if($4+0==-1){op3=op3"-h";$4=""};\
	if($5+0==-1){op3=op3"-k";$5=""};\
	if($6+0==-1){op3=op3"-l";$6=""};\
	if($4+0!=0)op3=op3"+h/"1/$4;\
	if($5+0!=0)op3=op3"+k/"1/$5;\
	if($6+0!=0)op3=op3"+l/"1/$6;\
    print "# cell",cell2,"->",cell1\
    print "reindex hkl",op1","op2","op3}' 




exit


R3 -> H3
reindex hkl h-k,k-l,h+k+l

H=h-k
K=k-l
L=h+k+l


H3 -> R3
reindex hkl 2h/3+k/3+l/3,-h/3+k/3+l/3,-h/3-2k/3+l/3

reindex match h'=h-k  * 2k'= -h +k + l * 1l'= 1h




